/* Problem URL: https://codeforces.com/problemset/problem/1912/K */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;

const ll mod = 998244353;
constexpr int MAXN = 2e5 + 10;
ll fact[MAXN];
ll inv[MAXN];
ll invf[MAXN];

ll comb(ll n, ll k) {
    return fact[n] * invf[k] % mod * invf[n - k] % mod;
}

void pre()
{
    fact[0] = 1;
    nrep(i, 1, MAXN) {
        fact[i] = fact[i - 1] * i % mod;
    }

    inv[1] = 1;
    nrep(i, 2, MAXN) {
        inv[i] = (mod - mod / i) * inv[mod % i] % mod;
    }

    invf[0] = 1;
    nrep(i, 1, MAXN) {
        invf[i] = invf[i - 1] * inv[i] % mod;
    }
}

#define TEST 0

void solve()
{
    int n;
    cin >> n;
    vl a(n);
    ll c = 0;
    repv(i, a) {
        cin >> i;
        c += ~i & 1;
    }

    ll ans = 0;
    nrep(i, 3, c + 1) {
        (ans += comb(c, i)) %= mod;
    }
    int seq[] = {1, 0, 1};

    vvvl memo(n, vvl(3, vl(2, -1)));
    auto init = [&]() {
        rep(i, n) {
            rep(j, 3) {
                rep(k, 2) {
                    memo[i][j][k] = -1;
                }
            }
        }
    };

    function<ll(int, int, int)> dp = [&](int i, int c, int val) {
        if (i >= n) {
            return 0LL;
        }

        ll &ans = memo[i][c][val];
        if (ans != -1) {
            return ans;
        }

        ans = 0;
        if (seq[c] == (a[i] & 1)) {
            (ans += dp(i + 1, (c + 1) % 3, val || (c == 2)) + (val || (c == 2))) %= mod;
        }
        (ans += dp(i + 1, c, val)) %= mod;
        return ans;
    };

    (ans += dp(0, 0, 0)) %= mod;
    seq[0] = 0;
    seq[1] = 1;
    init();
    (ans += dp(0, 0, 0)) %= mod;
    seq[0] = 1;
    seq[2] = 0;
    init();
    (ans += dp(0, 0, 0)) %= mod;

    cout << ans << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
